#version 430

// Size of work group - 256 threads
layout (local_size_x = 256) in;

// Input data in Shader Storage Buffers
layout (std140, binding = 0) buffer PositionsInBuffer
{
	vec4 particle_positions_read[];
};
layout (std140, binding = 1) buffer PositionsOutBuffer
{
	vec4 particle_positions_write[];
};
layout (std140, binding = 2) buffer VelocitiesBuffer
{
	vec4 particle_velocities[];
};

// Input data in uniform variables
uniform int current_particle_count;
uniform float time_delta;
uniform float accel_factor;
uniform float distance_threshold;

// Data shared between threads in work group - loaded positions
shared vec3 shared_positions[gl_WorkGroupSize.x];

void main()
{
	// Task 3: Copy here the result from nbody_compute.glsl, and then extend it with the use of shared memory.
	//		Hint: Variables:
	//			gl_LocalInvocationID.x    .. index of the current thread in its work group (local = references the threads in work group)
	//			gl_WorkGroupSize.x        .. size of a work group
	//			shared_positions          .. defined a few lines above, an array with data shared between threads in work group
	//			barrier()                 .. waits for other threads in work group, see the slides
}
